"""Added audit_log table

Revision ID: 81cbbf42357b
Revises: 6938f16617ab
Create Date: 2024-04-22 12:40:20.483528

"""
from alembic import op
import sqlalchemy as sa

# revision identifiers, used by Alembic.
revision = "81cbbf42357b"
down_revision = "6938f16617ab"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "audit_log",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("event_datetime", sa.DateTime(), nullable=True),
        sa.Column("event", sa.String(length=255), nullable=True),
        sa.Column("active_user_id", sa.Integer(), nullable=True),
        sa.Column("active_user_name", sa.String(length=255), nullable=True),
        sa.Column("affected_user_id", sa.Integer(), nullable=True),
        sa.Column("affected_account_id", sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(
            ["active_user_id"],
            ["fm_user.id"],
            name=op.f("audit_log_active_user_id_fm_user_fkey"),
            ondelete="SET NULL",
        ),
        sa.ForeignKeyConstraint(
            ["affected_account_id"],
            ["account.id"],
            name=op.f("audit_log_affected_account_id_account_fkey"),
            ondelete="SET NULL",
        ),
        sa.ForeignKeyConstraint(
            ["affected_user_id"],
            ["fm_user.id"],
            name=op.f("audit_log_affected_user_id_fm_user_fkey"),
            ondelete="SET NULL",
        ),
        sa.PrimaryKeyConstraint("id", name=op.f("audit_log_pkey")),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("audit_log")
    # ### end Alembic commands ###
